=== debian/changelog ===
cppad (2026.00.00.0-1) unstable; urgency=medium

  * remove now-obsolete RRR:no
  * uscan debian/watch version 5
  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 24 Jan 2026 10:40:22 +0000
