=== debian/watch ===
Version: 5

Source: https://github.com/coin-or/CppAD/tags
Matching-Pattern: .*/(\d\d\d\d)(\d\d)(\d\d)\.(\d+)@ARCHIVE_EXT@
